#include "BeQuakeApp_gl.h"

//******************
//BeQuakeApp
//******************

BeQuakeApp::BeQuakeApp(int argc, char *argv[])
	: BApplication("application/x-vnd.BeQuakeOpenGL")
{
	//This are setting width, hight, bpp from argv
	CheckArgv(argc, argv);
	
	if(FindClosestMode(width, hight, bpp, &orgmode, &newmode)){
		screen->SetMode(&newmode);
	}else{
		printf("Your setting at %d * %d did not work. trying 800*600\n",width,hight);
		if(FindClosestMode(800, 600, 32, &orgmode, &newmode)){
			screen->SetMode(&newmode);	
		}else{
			printf("That did not work ether using your normal resolution\n");
			screen = new BScreen(B_MAIN_SCREEN_ID);
		}
	}
	
	BRect screenRect = screen->Frame();
	mw = new BeQuakeWin(argc, argv, screenRect);
	mw->Show();
}

BeQuakeApp::~BeQuakeApp()
{
	screen->SetMode(&orgmode);
}

void BeQuakeApp::MessageReceived(BMessage *msg)
{
}

BeQuakeView * BeQuakeApp::GetBeQuakeView()
{
	return mw->GetBeQuakeView();
}

void BeQuakeApp::CheckArgv(int argc, char *argv[])
{
//	printf("argc %d\n", argc);
	int i, j, n;
	for (j=0 ; j < argc ; j++)
	{
//		printf("j = %d\n", j);
		if(!strcmp(argv[j], "-width")){
			width = atoi(argv[j+1]);
		}else if(!strcmp(argv[j], "-hight")){
			hight = atoi(argv[j+1]);
		}else if(!strcmp(argv[j], "-bpp")){
			bpp = atoi(argv[j+1]);
		}else if(!strcmp(argv[j], "-mode")){
			int nr = atoi(argv[j+1]);
			bpp = 16;
			switch (nr) {
	    		case 1:{
	    			width = 640;
					hight = 480;		
	    		}break;
	    		case 2:{
	    			width = 800;
					hight = 600;		
	    		}break;
	    		case 3:{
	    			width = 1024;
					hight = 764;		
	    		}break;
	    		case 4:{
	    			width = 1280;
					hight = 1024;		
	    		}break;
	    		case 5:{
	    			width = 320;
					hight = 200;
	    		}break;
	    		case 6:{
	    			width = 320;
					hight = 240;		
	    		}break;
	    		case 7:{
	    			width = 400;
					hight = 300;		
	    		}break;
	    		case 8:{
	    			width = 512;
					hight = 384;		
	    		}break;
			}
		}
	}	
}

/* Find the closest display mode for fullscreen */
bool BeQuakeApp::FindClosestMode(int width, int height, int bpp, display_mode *current, display_mode *newMode)
{
	BScreen bscreen;
	uint32 i, nmodes;
	display_mode *dmodes;
	float current_refresh;
	bscreen.GetMode(current);
	current_refresh = (1000 * current->timing.pixel_clock) / 
	                  (current->timing.h_total * current->timing.v_total);
	bscreen.GetModeList(&dmodes, &nmodes);
	for ( i = 0; i < nmodes; ++i ) {
		if ( (bpp == ColorSpaceToBitsPerPixel(dmodes[i].space)) &&
		     (width == dmodes[i].virtual_width) &&
		     (height == dmodes[i].virtual_height) ) {
			break;
		}
	}
	if ( i != nmodes ) {
		*newMode = dmodes[i];
		if ((newMode->virtual_width <= current->virtual_width) &&
		    (newMode->virtual_height <= current->virtual_height)) {
			float new_refresh = (1000 * newMode->timing.pixel_clock) /
			                    (newMode->timing.h_total * newMode->timing.v_total);
			if (new_refresh < current_refresh) {
				newMode->timing.pixel_clock = (uint32)((newMode->timing.h_total * newMode->timing.v_total)
				                                    * current_refresh / 1000);
			}
		}
		return true;
	} else {
		return false;
	}	
}
