#include <stdio.h>

#include <Screen.h>

#include "quake_beos_def_gl.h"

#include "BeQuakeWin_gl.h"
#include "BeQuakeView_gl.h"

class BeQuakeApp : public BApplication
{
 public: 
 	BeQuakeApp(int argc, char **argv);
 	~BeQuakeApp();
 	void MessageReceived(BMessage *msg);
 	BeQuakeView * GetBeQuakeView();
	bool FindClosestMode(int width, int height, int bpp, display_mode *current, display_mode *newMode);		
 private:
	void CheckArgv(int argc, char *argv[]);
	static inline int ColorSpaceToBitsPerPixel(uint32 colorspace); 
 	BeQuakeWin *mw;
 	display_mode orgmode;
 	display_mode newmode;
	uint32 i, nmodes;
	int width;
	int hight;
	int bpp;
 	BScreen *screen;
};

inline int BeQuakeApp::ColorSpaceToBitsPerPixel(uint32 colorspace)
{
	int bitsperpixel;

	bitsperpixel = 0;
	switch (colorspace) {
	    case B_CMAP8:
		bitsperpixel = 8;
		break;
	    case B_RGB15:
	    case B_RGBA15:
	    case B_RGB15_BIG:
	    case B_RGBA15_BIG:
		bitsperpixel = 15;
		break;
	    case B_RGB16:
	    case B_RGB16_BIG:
		bitsperpixel = 16;
		break;
	    case B_RGB32:
	    case B_RGBA32:
	    case B_RGB32_BIG:
	    case B_RGBA32_BIG:
		bitsperpixel = 32;
		break;
	    default:
		break;
	}
	return(bitsperpixel);
}
