/*
	Copyright 1999, Be Incorporated.   All Rights Reserved.
	This file may be used under the terms of the Be Sample Code License.
*/

// This defines an engine that tracks the state of the CD player
// and supports the CD player control and status calls

#ifndef __CD_BEOS___gl
#define __CD_BEOS___gl

#include <Looper.h>
#include <View.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <Debug.h>
#include <Directory.h>
#include "/boot/develop/headers/be/storage/Path.h"
#include <errno.h>
#include "scsi.h"
#include "scsiprobe_driver.h"
#include "/boot/develop/headers/be/storage/Entry.h"

typedef bool qboolean;
#define no = 0
#define yes = 1

typedef unsigned char byte;

extern "C"
{
void CDAudio_Play(byte track, qboolean looping);
void CDAudio_Stop(void);
void CDAudio_Pause(void);
void CDAudio_Resume(void);
void CDAudio_Update(void);
int CDAudio_Init(void);
void CDAudio_Shutdown(void);
void Con_Printf (char *fmt, ...);
}

static qboolean cdValid = true;
static qboolean	playing = false;
static qboolean	wasPlaying = false;
static qboolean	initialized = false;
static qboolean	enabled = true;
static qboolean playLooping = false;



class CDEngine : public BHandler {
	// The CD engine defines all the different CD control calls; also,
	// it hosts the different state watchers and helps them send notices
	// to observers about the CD state changes
public:
	CDEngine(int devicefd);
	CDEngine(BMessage *);

	virtual ~CDEngine();
	// control calls
	void PlayContinue();
	void Play(int32);
	void Pause();
	void Stop();
	bool IsCDPresent();
	//void Eject();
	//void SelectTrack(int32);
	static int FindCDPlayerDevice();
private:
	int devicefd;
};

CDEngine *engine;
#endif
