/*
Copyright (C) 1996-1997 Id Software, Inc.

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  

See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

*/
// in_beos.c -- BeOS mouse driver

#include "quakedef.h"

int	global_dx, global_dy;
int test1 = 0;
int test2 = 0;
int UseMouse = 1;

typedef struct
{
	qboolean Primary;
	qboolean Secondary;
	qboolean Tertiary;
	int dx;
	int dy;
//	cvar_t mouse_button_commands[3];
}mouse_pos;

mouse_pos BMouse_pos;

cvar_t _windowed_mouse = {"_windowed_mouse","1", true};


void IN_Init (void)
{
	Cvar_RegisterVariable(&_windowed_mouse);
	
	BMouse_pos.Primary = false;
	BMouse_pos.Secondary = false;
	BMouse_pos.Tertiary = false;
	BMouse_pos.dx = 0;
	BMouse_pos.dy = 0;
}

void IN_Shutdown (void)
{
}

void IN_Commands (void)
{
}

void IN_Move (usercmd_t *cmd)
{
	int dx, dy;

	if(BMouse_pos.Primary) 
		Key_Event(K_MOUSE1, true); 
	else 
		Key_Event(K_MOUSE1, false);
		
	if(BMouse_pos.Secondary) 
		Key_Event(K_MOUSE2, true);
	else 
		Key_Event(K_MOUSE2, false);
		
	if(BMouse_pos.Tertiary) 
		Key_Event(K_MOUSE3, true); 
	else 
		Key_Event(K_MOUSE3, false);

	BGetMouse();	
	dx = BMouse_pos.dx;
	dy = BMouse_pos.dy;
	
	dx *= sensitivity.value;
	dy *= sensitivity.value;

	if (!dx && !dy) {
		if (in_mlook.state & 1) 
			V_StopPitchDrift ();
		return;
	}

	if ((in_strafe.state & 1) || (lookstrafe.value && (in_mlook.state & 1)))
		cmd->sidemove += m_side.value * dx;
	else 
		cl.viewangles[YAW] -= m_yaw.value * dx;

	if (in_mlook.state & 1) 
		V_StopPitchDrift ();
	    
	if ((in_mlook.state & 1) && !(in_strafe.state & 1)) {
		cl.viewangles[PITCH] += m_pitch.value * dy;
		if (cl.viewangles[PITCH] > 80) 
			cl.viewangles[PITCH] = 80;
		if (cl.viewangles[PITCH] < -70) 
			cl.viewangles[PITCH] = -70;
	}
	else {
		if ((in_strafe.state & 1) && noclip_anglehack) 
			cmd->upmove -= m_forward.value * dy;
		else 
			cmd->forwardmove -= m_forward.value * dy;
	}
}
