#include "snd_beos_gl.h"

void BufferProc(void *theCookie, void *buffer, size_t size, const media_raw_audio_format &format)
{ 
if ( shm )
	{
	shm->buffer = (unsigned char *)buffer;
	shm->samplepos += size/(shm->samplebits/8);
	S_PaintChannels (shm->samplepos);
	}
}

qboolean SNDDMA_Init(void)
{
	snd_inited = 0;
	media_raw_audio_format format;

	format.format = media_raw_audio_format::B_AUDIO_SHORT; //16 bit samples
	format.byte_order = B_MEDIA_LITTLE_ENDIAN;
	format.frame_rate = 22050;
	format.channel_count = 2; //stereo
	format.buffer_size = 1024*format.channel_count;
	player = new BSoundPlayer(&format, "Qwav_player", BufferProc, NULL); 
	shm = &the_shm;
	shm->samplebits = 16;
	shm->splitbuffer = 0;
	shm->speed = format.frame_rate;
	shm->channels = format.channel_count;
	shm->samples = format.buffer_size;
	shm->samplepos = 0;
	shm->submission_chunk = 1;
	shm->buffer = NULL;
	player->Start(); 
	player->SetHasData(true); 
	snd_inited = 1;
	return 1;
}

int SNDDMA_GetDMAPos(void)
{
	return shm->samplepos;
}

void SNDDMA_Shutdown(void)
{
	if (snd_inited)
	{
		player->Stop();
		delete player;
		snd_inited = 0;
	}
}

void SNDDMA_Submit(void)
{
}
